{% macro graph_bar(value, name, suffix="", width=None) %}
    {% set width = width or value %}
    {% if width > 50 %}
        {% set outer_class = "" %}
        {% set margin = 50 %}
    {% else %}
        {% set outer_class = "reversed" %}
        {% set margin = width %}
    {% endif %}
    <div class="{{ name }} bar {{ outer_class }}">
        <div class="wrapper" style="width: {{ abs(width - 50)+0.1 }}%; margin-left: {{ margin }}%">
            <span>{{ round(value, 1) }}{{ suffix }}</span>
        </div>
    </div>
{% endmacro %}

<table class="graph_1d">
    <thead>
        <tr>
            <th class="title">{{ _('result_details.table.%s' % construct) }}</th>
            {% if with_titles %}
            <th class="description">{{ _('result_details.table.description') }}</th>
            <th class="values">
                <ul>
                    <li>{{ _('result_details.table.very_low') }}</li>
                    <li>{{ _('result_details.table.low') }}</li>
                    <li>{{ _('result_details.table.average_low') }}</li>
                    <li>{{ _('result_details.table.average_high') }}</li>
                    <li>{{ _('result_details.table.high') }}</li>
                    <li>{{ _('result_details.table.very_high') }}</li>
                </ul>
            </th>
            <th class="description">{{ _('result_details.table.description') }}</th>
            {% else %}
                <th></th>
                <th></th>
                <th></th>
            {% endif %}
        </tr>
    </thead>
    <tbody>
        {% for trait in score.extractor.get_maintraits(construct) %}
        {% set abbr = trait.abbreviation %}
        <tr {% if trait.is_maintrait %}class="maintrait"{% endif %}>
            <td class="title">{{ _(trait.title) }}</td>
            <td class="description">{{ _("result_details.table.description.%s.low" % trait.abbreviation)|markdown }}</td>
            <td class="values">
                {% set width = score.rawscore_percentages[abbr] %}
                {% set value = score.rawscore_averages[abbr] %}
                {{ graph_bar(value, 'rawscore', '', width) }}

                {% set tscore = round(score.tscores[abbr]) %}
                {% set width = (tscore - 20) * (5 / 3) %}
                {% set width = 100 if width > 100 else width %}
                {{ graph_bar(tscore, 'tscore', '', width) }}

                {% set percentile = int(score.percentiles[abbr]) %}
                {{ graph_bar(percentile, 'percentile', '', percentile) }}
            </td>
            <td class="description">{{ _("result_details.table.description.%s.high" % trait.abbreviation)|markdown }}</td>
        </tr>
        {% endfor %}
    </tbody>
</table>
